//+------------------------------------------------------------------+
//|                                                 iVAR browser.mq4 |
//| iVar calculation based on Ilnur work                             |
//| browser made by mladen                                           |
//+------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern string BrowserUniqueID = "iVarBrowser";
extern int    n               = 5;
extern double level           = 0.5;
extern int    nBars           = 500;
extern int    SortBy          = 1;
extern bool   ListVisible     = true;
extern int    ListCorner      = 1;
extern color  ListTextColor   = DimGray;
extern color  ListValueColor  = PaleVioletRed;

//
//
//
//
//

double ibuffer[];
int    ListWindow;
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
bool   returnBars;
string indicatorFileName;
string name;


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ibuffer); SetIndexLabel(0,"iVAR");
      indicatorFileName = WindowExpertName();
      returnBars        = (BrowserUniqueID=="returnBars"); if (returnBars) return(0);
      name              =  BrowserUniqueID+" iVAR broswer ("+n+")";
      SetLevelValue(0,level);
   IndicatorShortName(name);
   return(0);
}
int deinit() { deleteList(); return (0); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

#define LOG_2_0 0.69314718055994530941723212145818 //MathLog(2.0);
double  work[][9];
double  sortedTimeFrames[9];
double  sortedValues[9];
double  sortedPercentages[9];
double  sortedDuration[9];

//
//
//
//
//

int start()
{
   int j,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      if (returnBars) { ibuffer[0] = MathMin(nBars,MathMin(Bars-counted_bars,Bars-1)+1); return(0); }
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for (int t=0; t<9; t++)
   {
      int timeFrame = iTfTable[t];
      if (timeFrame != Period()) 
            limit = MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0));
      else  limit = MathMin(nBars,MathMin(Bars-counted_bars,Bars-1));
      
      //
      //
      //
      //
      //
      
      for(j=limit, r=Bars-j-1; j>=0; j--,r++)
      {
         double Sx  = 0; 
         double Sy  = 0; 
         double Sxx = 0; 
         double Sxy = 0;
         for(int i=0; i<=n; i++)
         {
            int    nInterval = 1 << (n-i); //MathPow(2,n-i);
            int    kCount    = 1 << i;     //MathPow(2,i);
            double Delta     = 0;

            for (int k=0; k<kCount; k++)
            {
               int nIntervalStart = nInterval*k+j;
               Delta += iHigh(NULL,timeFrame,iHighest(NULL,timeFrame,MODE_HIGH,nInterval,nIntervalStart))-
                        iLow( NULL,timeFrame,iLowest( NULL,timeFrame,MODE_LOW,nInterval,nIntervalStart));
            }
         
            double Xc = (n-i)*LOG_2_0; //MathLog(2.0);
            double Yc = MathLog(Delta);
         
            Sx  += Xc; 
            Sy  += Yc;
            Sxx += Xc*Xc; 
            Sxy += Xc*Yc;
         }
         work[r][t] = -(Sx*Sy-(n+1)*Sxy)/(Sx*Sx-(n+1)*Sxx); if (timeFrame==Period()) ibuffer[j] = work[r][t];
      }
      
      //
      //
      //
      //
      //
      
      sortedTimeFrames[t] = timeFrame;
      sortedValues[t]     = work[Bars-1][t];
         int state = 0;
            if (sortedValues[t] > level) state =  1;
            if (sortedValues[t] < level) state = -1;
            for (j=0, r=Bars-1; j<nBars; j++, r--)
            {
               int tstate = 0;
                  if (work[r][t] > level) tstate =  1;
                  if (work[r][t] < level) tstate = -1;
                  if (state != tstate) break;
            }
      sortedDuration[t] = j;
      sortedPercentages[t] = 0;            
            for (j=0, r=Bars-1; j<nBars; j++, r--) if (work[r][t] > level) sortedPercentages[t]++;
      sortedPercentages[t] /= nBars;
   }

   //
   //
   //
   //
   //
   
   for (i = 0;   i < 8; i++)
   for (j = i+1; j < 9; j++)
   {
      bool condition = false;
      switch (SortBy)
      {
         case 1  : condition = sortedValues[j] > sortedValues[i];     break;
         case 2  : condition = sortedDuration[j] > sortedDuration[i]; break;
         default : condition = sortedPercentages[j] > sortedPercentages[i]; 
      }         
      if (condition)
      {
         double temp1 = sortedTimeFrames[i];
         double temp2 = sortedValues[i];
         double temp3 = sortedDuration[i];
         double temp4 = sortedPercentages[i];
                       sortedTimeFrames[i]  = sortedTimeFrames[j];
                       sortedValues[i]      = sortedValues[j];
                       sortedDuration[i]    = sortedDuration[j];
                       sortedPercentages[i] = sortedPercentages[j];
                       sortedTimeFrames[j]  = temp1;
                       sortedValues[j]      = temp2;
                       sortedDuration[j]    = temp3;
                       sortedPercentages[j] = temp4;
      }
   }
   showList();      
   
   //
   //
   //
   //
   //
      
   SetIndexDrawBegin(0,Bars-nBars);
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void showList()
{
   if (ListVisible)
   {
      deleteList(); ListWindow = WindowFind(name);
         for (int i = 0; i < 9; i++) showElement(i+1,10,sortedTimeFrames[i],sortedPercentages[i],sortedValues[i],sortedDuration[i]);
   }               
}

//
//
//
//
//

void deleteList()
{
   string searchFor    = BrowserUniqueID+":";
   int    searchLength = StringLen(searchFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string tname = ObjectName(i); if (StringSubstr(tname,0,searchLength) == searchFor)
                                        ObjectDelete(tname);
   }
}

//
//
//
//
//

double xpos1[] = {310,285,240,190,140,100,42,10};
double xpos2[] = {10,90,125,165,215,265,310,365};

void showElement(int listNo, int totalElements, double timeFrame, double above, double value, double duration)
{
   double xpos[6];
   int    ypos;
   
   //
   //
   //
   //
   //
      
      if (ListCorner== 2 || ListCorner==3) 
            ypos = (totalElements-listNo+1)*11;
      else  ypos = listNo*11;         
      if (ListCorner== 1 || ListCorner==3)
            ArrayCopy(xpos,xpos1);
      else  ArrayCopy(xpos,xpos2);
      
      //
      //
      //
      //
      //
      
      setElement(listNo+"-0",xpos[0],ypos,ListTextColor ,listNo+" time frame :");
      setElement(listNo+"-1",xpos[1],ypos,ListValueColor,timeFrameToString(timeFrame));
      setElement(listNo+"-2",xpos[2],ypos,ListTextColor ,"above :");
      setElement(listNo+"-3",xpos[3],ypos,ListValueColor,DoubleToStr(100.0*above,2)+" %");
      setElement(listNo+"-4",xpos[4],ypos,ListTextColor ,"current :");
      setElement(listNo+"-5",xpos[5],ypos,ListValueColor,DoubleToStr(value,4));
      setElement(listNo+"-6",xpos[6],ypos,ListTextColor ,"duration :");
      setElement(listNo+"-7",xpos[7],ypos,ListValueColor,DoubleToStr(duration,0));
}

//
//
//
//
//

void setElement(string element, int x, int y, color ecolor=Silver, string text = "", int fontsize = 9, string fontname="Arial", int angle=0)
{
   string tname = BrowserUniqueID+":"+element;
   ObjectCreate(tname, OBJ_LABEL, ListWindow, 0, 0);
      ObjectSet(tname, OBJPROP_XDISTANCE, x);
      ObjectSet(tname, OBJPROP_YDISTANCE, y);
      ObjectSet(tname, OBJPROP_BACK, FALSE);
      ObjectSet(tname, OBJPROP_CORNER, ListCorner);
      ObjectSet(tname, OBJPROP_ANGLE, angle);
      ObjectSetText(tname, text, fontsize, fontname, ecolor);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

